]> git.ipfire.org Git - thirdparty/git.git/blame - git-stash.sh
stash: mark "git stash save" deprecated in the man page
[thirdparty/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
a5ab00c5
SB
4dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
fcdd0e92
SB
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
a5ab00c5 9 or: $dashless branch <branchname> [<stash>]
1ada5020
TG
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
a5ab00c5 15 or: $dashless clear"
f2c66ed1 16
3cd2491a 17SUBDIRECTORY_OK=Yes
8f321a39 18OPTIONS_SPEC=
d0ea45bf 19START_DIR=$(pwd)
f2c66ed1
NS
20. git-sh-setup
21require_work_tree
22fc703e 22prefix=$(git rev-parse --show-prefix) || exit 1
ceff079b 23cd_to_toplevel
f2c66ed1
NS
24
25TMP="$GIT_DIR/.git-stash.$$"
c697b577 26TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
3ba2e865 27trap 'rm -f "$TMP-"* "$TMPindex"' 0
f2c66ed1
NS
28
29ref_stash=refs/stash
30
dda1f2a5
TR
31if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34else
35 help_color=
36 reset_color=
37fi
38
f2c66ed1 39no_changes () {
df6bba09
TG
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
78751302
DC
42 (test -z "$untracked" || test -z "$(untracked_files)")
43}
44
45untracked_files () {
5fc92f88
KD
46 if test "$1" = "-z"
47 then
48 shift
49 z=-z
50 else
51 z=
52 fi
78751302
DC
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
5fc92f88 55 git ls-files -o $z $excl_opt -- "$@"
f2c66ed1
NS
56}
57
58clear_stash () {
3023dc69
JH
59 if test $# != 0
60 then
b1440ce2 61 die "$(gettext "git stash clear with parameters is unimplemented")"
3023dc69 62 fi
1956dfa8 63 if current=$(git rev-parse --verify --quiet $ref_stash)
7ab3cc70 64 then
a9ee9bf9 65 git update-ref -d $ref_stash $current
7ab3cc70 66 fi
f2c66ed1
NS
67}
68
bc9e7399 69create_stash () {
9ca6326d
TG
70 stash_msg=
71 untracked=
72 while test $# != 0
73 do
74 case "$1" in
75 -m|--message)
76 shift
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
78 ;;
79 -u|--include-untracked)
80 shift
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
82 ;;
df6bba09
TG
83 --)
84 shift
85 break
86 ;;
9ca6326d
TG
87 esac
88 shift
89 done
9f62e18a 90
1eff26c0 91 git update-index -q --refresh
df6bba09 92 if no_changes "$@"
f2c66ed1 93 then
f2c66ed1
NS
94 exit 0
95 fi
f12e925a 96
f2c66ed1 97 # state of the base commit
5be60078 98 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 99 then
b0e621ad 100 head=$(git rev-list --oneline -n 1 HEAD --)
f2c66ed1 101 else
b1440ce2 102 die "$(gettext "You do not have the initial commit yet")"
f2c66ed1
NS
103 fi
104
5be60078 105 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
106 then
107 branch=${branch#refs/heads/}
108 else
109 branch='(no branch)'
110 fi
111 msg=$(printf '%s: %s' "$branch" "$head")
112
113 # state of the index
5be60078 114 i_tree=$(git write-tree) &&
6143fa2c 115 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 116 git commit-tree $i_tree -p $b_commit) ||
b1440ce2 117 die "$(gettext "Cannot save the current index state")"
f2c66ed1 118
78751302
DC
119 if test -n "$untracked"
120 then
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
123 u_commit=$(
5fc92f88 124 untracked_files -z "$@" | (
bed137d2
EP
125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
78751302
DC
127 rm -f "$TMPindex" &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
131 rm -f "$TMPindex"
850251f3 132 ) ) || die "$(gettext "Cannot save the untracked files")"
78751302
DC
133
134 untracked_commit_option="-p $u_commit";
135 else
136 untracked_commit_option=
137 fi
138
dda1f2a5
TR
139 if test -z "$patch_mode"
140 then
141
142 # state of the working tree
143 w_tree=$( (
3ba2e865
JS
144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
dda1f2a5 146 export GIT_INDEX_FILE &&
df6bba09 147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
44df2e29 148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
dda1f2a5 149 git write-tree &&
3ba2e865 150 rm -f "$TMPindex"
dda1f2a5 151 ) ) ||
b1440ce2 152 die "$(gettext "Cannot save the current worktree state")"
dda1f2a5
TR
153
154 else
155
b24f56d6 156 rm -f "$TMP-index" &&
dda1f2a5
TR
157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
158
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
df6bba09 161 git add--interactive --patch=stash -- "$@" &&
dda1f2a5
TR
162
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
b1440ce2 165 die "$(gettext "Cannot save the current worktree state")"
f2c66ed1 166
44df2e29 167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
dda1f2a5 168 test -s "$TMP-patch" ||
b1440ce2 169 die "$(gettext "No changes selected")"
dda1f2a5
TR
170
171 rm -f "$TMP-index" ||
b1440ce2 172 die "$(gettext "Cannot remove temporary index (can't happen)")"
dda1f2a5
TR
173
174 fi
175
f2c66ed1 176 # create the stash
9f62e18a
JH
177 if test -z "$stash_msg"
178 then
179 stash_msg=$(printf 'WIP on %s' "$msg")
180 else
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
182 fi
183 w_commit=$(printf '%s\n' "$stash_msg" |
22f41286
JH
184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
bc9e7399 186}
f2c66ed1 187
bd514cad
RR
188store_stash () {
189 while test $# != 0
190 do
191 case "$1" in
192 -m|--message)
193 shift
194 stash_msg="$1"
195 ;;
196 -q|--quiet)
197 quiet=t
198 ;;
199 *)
200 break
201 ;;
202 esac
203 shift
204 done
205 test $# = 1 ||
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
207
208 w_commit="$1"
209 if test -z "$stash_msg"
210 then
211 stash_msg="Created via \"git stash store\"."
212 fi
213
89dea973 214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
bd514cad 215 ret=$?
268ef4d3 216 test $ret != 0 && test -z "$quiet" &&
bd514cad
RR
217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218 return $ret
219}
220
f5727e26 221push_stash () {
7bedebca 222 keep_index=
dda1f2a5 223 patch_mode=
78751302 224 untracked=
f5727e26 225 stash_msg=
fcdd0e92
SB
226 while test $# != 0
227 do
228 case "$1" in
ea41cfc4 229 -k|--keep-index)
fcdd0e92
SB
230 keep_index=t
231 ;;
dda1f2a5 232 --no-keep-index)
3a243f70 233 keep_index=n
dda1f2a5
TR
234 ;;
235 -p|--patch)
236 patch_mode=t
3a243f70
DM
237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
fcdd0e92
SB
239 ;;
240 -q|--quiet)
241 GIT_QUIET=t
242 ;;
78751302
DC
243 -u|--include-untracked)
244 untracked=untracked
245 ;;
246 -a|--all)
247 untracked=all
248 ;;
f5727e26
TG
249 -m|--message)
250 shift
251 test -z ${1+x} && usage
252 stash_msg=$1
253 ;;
5ba28313
JK
254 --help)
255 show_help
256 ;;
3c2eb80f
MM
257 --)
258 shift
259 break
260 ;;
261 -*)
eed10649
ÆAB
262 option="$1"
263 # TRANSLATORS: $option is an invalid option, like
264 # `--blah-blah'. The 7 spaces at the beginning of the
265 # second line correspond to "error: ". So you should line
266 # up the second line with however many characters the
267 # translation of "error: " takes in your language. E.g. in
268 # English this is:
269 #
db37745e
TG
270 # $ git stash push --blah-blah 2>&1 | head -n 2
271 # error: unknown option for 'stash push': --blah-blah
272 # To provide a message, use git stash push -m '--blah-blah'
273 eval_gettextln "error: unknown option for 'stash push': \$option
274 To provide a message, use git stash push -m '\$option'"
3c2eb80f
MM
275 usage
276 ;;
fcdd0e92
SB
277 *)
278 break
279 ;;
280 esac
7bedebca 281 shift
fcdd0e92 282 done
7bedebca 283
22fc703e
PS
284 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
285
78751302
DC
286 if test -n "$patch_mode" && test -n "$untracked"
287 then
850251f3 288 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
78751302
DC
289 fi
290
df6bba09
TG
291 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
292
1eff26c0 293 git update-index -q --refresh
df6bba09 294 if no_changes "$@"
bc9e7399 295 then
5a175871 296 say "$(gettext "No local changes to save")"
bc9e7399
JH
297 exit 0
298 fi
df6bba09 299
89dea973 300 git reflog exists $ref_stash ||
b1440ce2 301 clear_stash || die "$(gettext "Cannot initialize stash")"
bc9e7399 302
df6bba09 303 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
bd514cad
RR
304 store_stash -m "$stash_msg" -q $w_commit ||
305 die "$(gettext "Cannot save the current status")"
599e7a0b 306 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
7bedebca 307
dda1f2a5 308 if test -z "$patch_mode"
7bedebca 309 then
bbffd87d
NMC
310 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
311 if test -n "$untracked"
312 then
313 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
314 fi
315
df6bba09
TG
316 if test $# != 0
317 then
1790f4fe 318 git reset -q -- "$@"
df6bba09
TG
319 git ls-files -z --modified -- "$@" |
320 git checkout-index -z --force --stdin
1790f4fe 321 git clean --force -q -d -- "$@"
df6bba09 322 else
1790f4fe 323 git reset --hard -q
df6bba09 324 fi
dda1f2a5 325
268ef4d3 326 if test "$keep_index" = "t" && test -n "$i_tree"
dda1f2a5 327 then
e0e7f99e
TG
328 git read-tree --reset $i_tree
329 git ls-files -z --modified -- "$@" |
330 git checkout-index -z --force --stdin
dda1f2a5
TR
331 fi
332 else
333 git apply -R < "$TMP-patch" ||
b1440ce2 334 die "$(gettext "Cannot remove worktree changes")"
dda1f2a5 335
3a243f70 336 if test "$keep_index" != "t"
dda1f2a5 337 then
869fb8f7 338 git reset -q -- "$@"
dda1f2a5 339 fi
7bedebca 340 fi
f2c66ed1
NS
341}
342
f5727e26
TG
343save_stash () {
344 push_options=
345 while test $# != 0
346 do
347 case "$1" in
348 --)
349 shift
350 break
351 ;;
352 -*)
353 # pass all options through to push_stash
354 push_options="$push_options $1"
355 ;;
356 *)
357 break
358 ;;
359 esac
360 shift
361 done
362
363 stash_msg="$*"
364
365 if test -z "$stash_msg"
366 then
367 push_stash $push_options
368 else
369 push_stash $push_options -m "$stash_msg"
370 fi
371}
372
401de405 373have_stash () {
1956dfa8 374 git rev-parse --verify --quiet $ref_stash >/dev/null
401de405
JK
375}
376
f2c66ed1 377list_stash () {
401de405 378 have_stash || return 0
288c67ca 379 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
f2c66ed1
NS
380}
381
382show_stash () {
d6cc2df5 383 ALLOW_UNKNOWN_FLAGS=t
a9bf09e1 384 assert_stash_like "$@"
14cd4581 385
3086c064
NK
386 if test -z "$FLAGS"
387 then
388 if test "$(git config --bool stash.showStat || echo true)" = "true"
389 then
390 FLAGS=--stat
391 fi
392
393 if test "$(git config --bool stash.showPatch || echo false)" = "true"
394 then
395 FLAGS=${FLAGS}${FLAGS:+ }-p
396 fi
397
398 if test -z "$FLAGS"
399 then
400 return 0
401 fi
402 fi
403
404 git diff ${FLAGS} $b_commit $w_commit
f2c66ed1
NS
405}
406
5ba28313
JK
407show_help () {
408 exec git help stash
409 exit 1
410}
411
ef763129
JS
412#
413# Parses the remaining options looking for flags and
414# at most one revision defaulting to ${ref_stash}@{0}
415# if none found.
416#
417# Derives related tree and commit objects from the
418# revision, if one is found.
419#
420# stash records the work tree, and is a merge between the
421# base commit (first parent) and the index tree (second parent).
422#
423# REV is set to the symbolic version of the specified stash-like commit
424# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
425# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
426# s is set to the SHA1 of the stash commit
427# w_commit is set to the commit containing the working tree
428# b_commit is set to the base commit
429# i_commit is set to the commit containing the index tree
78751302 430# u_commit is set to the commit containing the untracked files tree
ef763129
JS
431# w_tree is set to the working tree
432# b_tree is set to the base tree
433# i_tree is set to the index tree
78751302 434# u_tree is set to the untracked files tree
ef763129
JS
435#
436# GIT_QUIET is set to t if -q is specified
437# INDEX_OPTION is set to --index if --index is specified.
d6cc2df5 438# FLAGS is set to the remaining flags (if allowed)
ef763129
JS
439#
440# dies if:
441# * too many revisions specified
442# * no revision is specified and there is no stash stack
443# * a revision is specified which cannot be resolve to a SHA1
444# * a non-existent stash reference is specified
d6cc2df5 445# * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
ef763129
JS
446#
447
448parse_flags_and_rev()
449{
450 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
451 PARSE_CACHE="$*"
452
453 IS_STASH_LIKE=
454 IS_STASH_REF=
455 INDEX_OPTION=
456 s=
457 w_commit=
458 b_commit=
459 i_commit=
78751302 460 u_commit=
ef763129
JS
461 w_tree=
462 b_tree=
463 i_tree=
78751302 464 u_tree=
ef763129 465
ef763129 466 FLAGS=
a56c8f5a 467 REV=
2bea593b 468 for opt
ef763129 469 do
2bea593b
JS
470 case "$opt" in
471 -q|--quiet)
472 GIT_QUIET=-t
473 ;;
ef763129
JS
474 --index)
475 INDEX_OPTION=--index
476 ;;
5ba28313
JK
477 --help)
478 show_help
479 ;;
2bea593b 480 -*)
d6cc2df5
JK
481 test "$ALLOW_UNKNOWN_FLAGS" = t ||
482 die "$(eval_gettext "unknown option: \$opt")"
2bea593b 483 FLAGS="${FLAGS}${FLAGS:+ }$opt"
ef763129 484 ;;
a56c8f5a
AW
485 *)
486 REV="${REV}${REV:+ }'$opt'"
487 ;;
ef763129 488 esac
ef763129
JS
489 done
490
2a07e437 491 eval set -- $REV
ef763129
JS
492
493 case $# in
494 0)
e01db917 495 have_stash || die "$(gettext "No stash entries found.")"
ef763129
JS
496 set -- ${ref_stash}@{0}
497 ;;
498 1)
499 :
500 ;;
501 *)
33ceddcf 502 die "$(eval_gettext "Too many revisions specified: \$REV")"
ef763129
JS
503 ;;
504 esac
505
a56c8f5a
AW
506 case "$1" in
507 *[!0-9]*)
508 :
509 ;;
510 *)
511 set -- "${ref_stash}@{$1}"
512 ;;
513 esac
514
1956dfa8 515 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
155da748 516 reference="$1"
ad5fe377 517 die "$(eval_gettext "\$reference is not a valid reference")"
155da748 518 }
ef763129 519
1956dfa8 520 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
2a07e437 521 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
ef763129
JS
522 s=$1 &&
523 w_commit=$1 &&
524 b_commit=$2 &&
525 w_tree=$3 &&
526 b_tree=$4 &&
527 i_tree=$5 &&
528 IS_STASH_LIKE=t &&
529 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
530 IS_STASH_REF=t
78751302 531
1956dfa8 532 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
2a07e437 533 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
ef763129
JS
534}
535
536is_stash_like()
537{
538 parse_flags_and_rev "$@"
539 test -n "$IS_STASH_LIKE"
540}
541
542assert_stash_like() {
777b6f13
ÆAB
543 is_stash_like "$@" || {
544 args="$*"
545 die "$(eval_gettext "'\$args' is not a stash-like commit")"
546 }
ef763129
JS
547}
548
549is_stash_ref() {
550 is_stash_like "$@" && test -n "$IS_STASH_REF"
551}
552
553assert_stash_ref() {
777b6f13
ÆAB
554 is_stash_ref "$@" || {
555 args="$*"
556 die "$(eval_gettext "'\$args' is not a stash reference")"
557 }
ef763129
JS
558}
559
f2c66ed1 560apply_stash () {
fcdd0e92 561
064ed100 562 assert_stash_like "$@"
f2c66ed1 563
b1440ce2 564 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
5fd448f1
OA
565
566 # current index state
567 c_tree=$(git write-tree) ||
b1440ce2 568 die "$(gettext "Cannot apply a stash in the middle of a merge")"
5fd448f1 569
cbeaccc3 570 unstashed_index_tree=
064ed100 571 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
7bedebca 572 test "$c_tree" != "$i_tree"
cbeaccc3 573 then
89d750bf 574 git diff-tree --binary $s^2^..$s^2 | git apply --cached
150937c4 575 test $? -ne 0 &&
b1440ce2 576 die "$(gettext "Conflicts in index. Try without --index.")"
52070790 577 unstashed_index_tree=$(git write-tree) ||
b1440ce2 578 die "$(gettext "Could not save index tree")"
150937c4 579 git reset
cbeaccc3 580 fi
150937c4 581
78751302
DC
582 if test -n "$u_tree"
583 then
974ce807 584 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
78751302
DC
585 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
586 rm -f "$TMPindex" ||
e01db917 587 die "$(gettext "Could not restore untracked files from stash entry")"
78751302
DC
588 fi
589
f2c66ed1
NS
590 eval "
591 GITHEAD_$w_tree='Stashed changes' &&
592 GITHEAD_$c_tree='Updated upstream' &&
593 GITHEAD_$b_tree='Version stash was based on' &&
594 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
595 "
596
fcdd0e92
SB
597 if test -n "$GIT_QUIET"
598 then
69ae92bd 599 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
fcdd0e92 600 fi
52070790 601 if git merge-recursive $b_tree -- $c_tree $w_tree
f2c66ed1
NS
602 then
603 # No conflict
cbeaccc3
JH
604 if test -n "$unstashed_index_tree"
605 then
606 git read-tree "$unstashed_index_tree"
83b3df7d
JH
607 else
608 a="$TMP-added" &&
89d750bf 609 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
83b3df7d
JH
610 git read-tree --reset $c_tree &&
611 git update-index --add --stdin <"$a" ||
b1440ce2 612 die "$(gettext "Cannot unstage modified files")"
83b3df7d 613 rm -f "$a"
cbeaccc3 614 fi
fcdd0e92
SB
615 squelch=
616 if test -n "$GIT_QUIET"
617 then
618 squelch='>/dev/null 2>&1'
619 fi
26b59b48 620 (cd "$START_DIR" && eval "git status $squelch") || :
f2c66ed1
NS
621 else
622 # Merge conflict; keep the exit status from merge-recursive
150937c4 623 status=$?
743bf6d8 624 git rerere
064ed100 625 if test -n "$INDEX_OPTION"
cbeaccc3 626 then
6fdd50e9 627 gettextln "Index was not unstashed." >&2
cbeaccc3 628 fi
150937c4 629 exit $status
f2c66ed1
NS
630 fi
631}
632
f276872d
JS
633pop_stash() {
634 assert_stash_ref "$@"
635
2d4c9933
JH
636 if apply_stash "$@"
637 then
638 drop_stash "$@"
639 else
640 status=$?
e01db917 641 say "$(gettext "The stash entry is kept in case you need it again.")"
2d4c9933
JH
642 exit $status
643 fi
f276872d
JS
644}
645
e25d5f9c 646drop_stash () {
92e39e44 647 assert_stash_ref "$@"
e25d5f9c 648
92e39e44 649 git reflog delete --updateref --rewrite "${REV}" &&
d4ca6c8b
ÆAB
650 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
651 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
e25d5f9c
BC
652
653 # clear_stash if we just dropped the last stash entry
1956dfa8
DA
654 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
655 clear_stash
e25d5f9c
BC
656}
657
656b5034 658apply_to_branch () {
b1440ce2 659 test -n "$1" || die "$(gettext "No branch name specified")"
656b5034 660 branch=$1
fb433dc9 661 shift 1
656b5034 662
fb433dc9
JS
663 set -- --index "$@"
664 assert_stash_like "$@"
665
666 git checkout -b $branch $REV^ &&
57693d03
JS
667 apply_stash "$@" && {
668 test -z "$IS_STASH_REF" || drop_stash "$@"
669 }
656b5034
AMS
670}
671
9e140909
TG
672test "$1" = "-p" && set "push" "$@"
673
ef763129 674PARSE_CACHE='--not-parsed'
1ada5020 675# The default command is "push" if nothing but options are given
3c2eb80f
MM
676seen_non_option=
677for opt
678do
679 case "$opt" in
9e140909 680 --) break ;;
3c2eb80f
MM
681 -*) ;;
682 *) seen_non_option=t; break ;;
683 esac
684done
685
1ada5020 686test -n "$seen_non_option" || set "push" "$@"
3c2eb80f 687
f2c66ed1
NS
688# Main command set
689case "$1" in
fcb10a96
JH
690list)
691 shift
f2c66ed1
NS
692 list_stash "$@"
693 ;;
694show)
695 shift
696 show_stash "$@"
697 ;;
683befa1
KL
698save)
699 shift
47629dcf 700 save_stash "$@"
683befa1 701 ;;
f5727e26
TG
702push)
703 shift
704 push_stash "$@"
705 ;;
f2c66ed1
NS
706apply)
707 shift
708 apply_stash "$@"
709 ;;
710clear)
3023dc69
JH
711 shift
712 clear_stash "$@"
f2c66ed1 713 ;;
bc9e7399 714create)
0719f300 715 shift
9ca6326d 716 create_stash -m "$*" && echo "$w_commit"
bc9e7399 717 ;;
bd514cad
RR
718store)
719 shift
720 store_stash "$@"
721 ;;
e25d5f9c
BC
722drop)
723 shift
724 drop_stash "$@"
725 ;;
bd56ff54
BC
726pop)
727 shift
f276872d 728 pop_stash "$@"
bd56ff54 729 ;;
656b5034
AMS
730branch)
731 shift
732 apply_to_branch "$@"
733 ;;
f2c66ed1 734*)
3c2eb80f
MM
735 case $# in
736 0)
1ada5020 737 push_stash &&
5a175871 738 say "$(gettext "(To restore them type \"git stash apply\")")"
ea41cfc4
JS
739 ;;
740 *)
683befa1 741 usage
ea41cfc4 742 esac
9f62e18a 743 ;;
f2c66ed1 744esac